SystemOrganization addCategory: #'Magritte-Seaside-Core'!
SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Decorations'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!

MAVisitor subclass: #MAComponentRenderer
	instanceVariableNames: 'component html errors group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MAComponentRenderer class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
component: aComponent on: aRenderer
	^ self new component: aComponent on: aRenderer! !

!MAComponentRenderer methodsFor: 'private' stamp: 'lr 10/27/2007 12:04'!
childAt: aDescription
	^ component childAt: aDescription! !

!MAComponentRenderer methodsFor: 'private' stamp: 'lr 1/10/2008 15:58'!
classFor: aDescription
	| classes |
	classes := OrderedCollection withAll: aDescription cssClasses.
	aDescription isReadonly
		ifTrue: [ classes add: 'readonly' ].
	aDescription isRequired
		ifTrue: [ classes add: 'required' ].
	(self hasError: aDescription)
		ifTrue: [ classes add: 'error' ].
	^ classes reduce: [ :a :b | a , ' ' , b ]! !

!MAComponentRenderer methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:33'!
component: aComponent on: aRenderer
	self setComponent: aComponent; setRenderer: aRenderer.
	self visit: aComponent description! !

!MAComponentRenderer methodsFor: 'testing' stamp: 'lr 10/27/2007 12:09'!
hasError: aDescription
	errors ifNotNil: [ ^ errors includes: aDescription ].
	errors := IdentitySet new.
	component errors do: [ :each |
		errors add: (each tag isDescription
			ifTrue: [ each tag ]
			ifFalse: [ component description ]) ].
	^ self hasError: aDescription! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderContainer: aDescription
	self visitAll: (aDescription select: [ :each |
		each isVisible
			and: [ each componentClass notNil ] ])! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'pmm 12/15/2006 16:54'!
renderControl: aDescription
	html render: (self childAt: aDescription)! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 10/27/2007 12:03'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
	self renderLabel: aDescription.
	self renderControl: aDescription! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 10/27/2007 12:09'!
renderGroup: aDescription
	group := aDescription group! !

!MAComponentRenderer methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:39'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [ html render: aDescription label; text: ':' ]! !

!MAComponentRenderer methodsFor: 'initilization' stamp: 'lr 3/9/2006 11:33'!
setComponent: aComponent
	component := aComponent! !

!MAComponentRenderer methodsFor: 'initilization' stamp: 'lr 3/9/2006 11:33'!
setRenderer: aRenderer
	html := aRenderer! !

!MAComponentRenderer methodsFor: 'visiting-description' stamp: 'lr 3/9/2006 11:33'!
visitContainer: aDescription
	self renderContainer: aDescription! !

!MAComponentRenderer methodsFor: 'visiting-description' stamp: 'lr 3/9/2006 11:33'!
visitElementDescription: aDescription
	self renderElement: aDescription! !

MAComponentRenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/18/2008 18:30'!
renderContainer: aDescription 
	html definitionList
		class: (self classFor: aDescription);
		with: [ super renderContainer: aDescription ]! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:21'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 10/27/2007 12:12'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:21'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAComponentRenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:04'!
renderContainer: aDescription 
	html table
		class: (self classFor: aDescription);
		with: [super renderContainer: aDescription]! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:18'!
renderControl: aDescription
	html tableData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:26'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
	html tableRow: [ 
		self renderLabel: aDescription.
		self renderControl: aDescription ]! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 10/27/2007 12:15'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html tableRow class: 'group'; with: [ 
		html tableHeading
			colSpan: 2;
			with: group ]! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:22'!
renderLabel: aDescription
	html tableHeading
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:58'!
renderDefaultOn: html
	<mimetype: #isApplication priority: 0>

	html anchor
		url: (self urlOn: html);
		with: self filename! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:54'!
renderImageOn: html
	<mimetype: #isImage priority: 0>

	html image url: (self urlOn: html)! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 19:10'!
renderMediaOn: html
	<mimetype: #isVideo priority: 0>
	<mimetype: #isAudio priority: 0>

	| url |
	url := self urlOn: html.
	(html tag: 'object') 
		attributeAt: 'data' put: url;
		attributeAt: 'type' put: self mimetype;
		with: [ 
			(html tag: 'param')
				attributeAt: 'name' put: 'src';
				with: url.
			(html tag: 'param')
				attributeAt: 'name' put: 'scale';
				with: 'aspect'.
			(html tag: 'param')
				attributeAt: 'name' put: 'autoplay';
				with: 'false'.
			(html tag: 'embed')
				attributeAt: 'src' put: url;
				attributeAt: 'scale' put: 'aspect';
				attributeAt: 'autoplay' put: 'false';
				attributeAt: 'type' put: self mimetype;
				with: [ self renderDefaultOn: html ] ]! !

!MAFileModel methodsFor: '*magritte-seaside-rendering' stamp: 'lr 2/8/2009 18:57'!
renderOn: html
	| pragmas |
	pragmas := Pragma
		allNamed: #mimetype:priority:
		from: self class to: MAFileModel
		sortedByArgument: 2.
	pragmas do: [ :pragma |
		(self perform: pragma arguments first)
			ifTrue: [ ^ self perform: pragma selector with: html ] ].
	self renderDefaultOn: html! !

!MAFileModel methodsFor: '*magritte-seaside-rendering-mimetypes' stamp: 'lr 2/8/2009 18:55'!
renderTextOn: html
	<mimetype: #isText priority: 0>

	| stream |
	stream := self contents readStream.
	html preformatted: [
		html text: (stream next: 800).
		stream atEnd
			ifFalse: [ html text: '...' ] ]! !

!MAFileModel methodsFor: '*magritte-seaside-rendering' stamp: 'lr 1/26/2007 18:54'!
urlOn: html
	^ html context
		urlForDocument: self contents
		mimeType: self mimetype
		fileName: self filename! !

!MADurationDescription class methodsFor: '*magritte-seaside' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATextInputComponent! !

WADecoration subclass: #MAComponentDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

MAComponentDecoration subclass: #MAContainerDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 8/19/2008 22:25'!
buttons
	"Answer a collection of associations. The key is either a symbol that will be performed on the decorated component or a one-argument block that will be executed with the component as argument. The value is the button label."
	
	self subclassResponsibility! !

!MAContainerDecoration methodsFor: 'accessing' stamp: 'lr 4/5/2007 17:12'!
default
	^ self buttons first key! !

!MAContainerDecoration methodsFor: 'actions' stamp: 'lr 8/19/2008 22:24'!
execute: anObject
	anObject isSymbol
		ifFalse: [ anObject value: self component ]
		ifTrue: [ self component perform: anObject ]! !

!MAContainerDecoration methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isMultipart
	^ self component isMultipart! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'sebh 6/14/2009 17:38'!
renderButtonsOn: html
	html div class: 'buttons'; with: [
		self buttons do: [ :each |
			html submitButton
				id: 'button', each value;
				accessKey: each value first;
				callback: [ self execute: each key ];
				text: each value ] ]! !

!MAContainerDecoration methodsFor: 'rendering' stamp: 'lr 8/19/2008 22:19'!
renderContentOn: html
	html form
		class: 'magritte';
		multipart: self isMultipart;
		defaultAction: [ self execute: self default ];
		with: [ self renderOwnerOn: html; renderButtonsOn: html ]! !

MAContainerDecoration subclass: #MAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAFormDecoration commentStamp: 'lr 8/12/2008 09:26' prior: 0!
I surround the owning component with a XHTML form element and render the form buttons.!

!MAFormDecoration class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
buttons: aCollection
	^ self new
		addButtons: aCollection;
		yourself! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 8/19/2008 22:25'!
addButton: aSymbol
	self addButton: aSymbol label: (self labelForSelector: aSymbol)! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 8/19/2008 22:25'!
addButton: aSymbolOrOneArgumentBlock label: aString
	self buttons add: aSymbolOrOneArgumentBlock -> aString! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
addButtons: aCollection
	aCollection do: [ :each |
		each isVariableBinding
			ifFalse: [ self addButton: each ]
			ifTrue: [ self addButton: each key label: each value ] ]! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
buttons
	^ buttons! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
buttons: aCollection
	buttons := aCollection! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
initialize
	super initialize.
	self buttons: OrderedCollection new! !

MAContainerDecoration subclass: #MASwitchDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MASwitchDecoration commentStamp: 'lr 8/12/2008 09:26' prior: 0!
I turn the owning component read-only and add an edit button. Clicking that button allows one to toggle between view and edit-mode.!

!MASwitchDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
buttons
	^ self component isReadonly
		ifTrue: [ Array with: #edit -> 'Edit' ]
		ifFalse: [ Array with: #save -> 'Save' with: #cancel -> 'Cancel' ]! !

!MASwitchDecoration methodsFor: 'processing' stamp: 'lr 3/9/2006 11:34'!
handleAnswer: anObject continueWith: aBlock
	self component readonly: true.
	super handleAnswer: anObject continueWith: aBlock! !

MAComponentDecoration subclass: #MAValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Decorations'!

!MAValidationDecoration commentStamp: 'lr 8/12/2008 09:22' prior: 0!
I am a normally invisible component. I show a list of validation errors in case the owner component fails to validate.!

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/20/2007 13:35'!
errors
	^ self component errors! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 4/20/2007 14:06'!
renderContentOn: html
	self errors isEmpty
		ifFalse: [ self renderErrorsOn: html ].
	self renderOwnerOn: html! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 9/12/2007 17:27'!
renderErrorsOn: html
	html unorderedList
		class: 'errors';
		list: self errors;
		with: nil! !

!MAExternalFileModel methodsFor: '*magritte-seaside-accessing' stamp: 'lr 9/28/2007 07:45'!
urlOn: html
	^ self baseUrl isNil
		ifTrue: [ super urlOn: html ]
		ifFalse: [ self baseUrl , '/' , (self location reduce: [ :a :b | a , '/' , b ]) , '/' , self filename ]! !

!MAFileDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAFileUploadComponent! !

!MADateDescription class methodsFor: '*magritte-seaside' stamp: 'pmm 10/22/2006 08:14'!
defaultComponentClasses
	^ Array with: MADateInputComponent with: MADateSelectorComponent! !

!MASingleOptionDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MASelectListComponent with: MARadioGroupComponent! !

!Symbol methodsFor: '*magritte-seaside' stamp: 'lr 8/14/2006 10:59'!
fixTemps
	^ self! !

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MAColumn subclass: #MAActionColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ String new! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultUseLinks
	^ true! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellContent: anObject on: html
	self useLinks
		ifTrue: [ self renderCellLinkContent: anObject on: html ]
		ifFalse: [ self renderCellFormContent: anObject on: html ]! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellFormContent: anObject on: html
	self subclassResponsibility! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellLinkContent: anObject  on: html
	self subclassResponsibility! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
useLinks
	^ self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ]! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean! !

MAActionColumn subclass: #MACommandColumn
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
addCommand: aBlock text: aString
	self commands add: aBlock -> aString! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
addCommandOn: anObject selector: aSelector
	self addCommandOn: anObject selector: aSelector text: aSelector allButLast asCapitalizedPhrase! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
commands
	^ commands! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
commands: aCollection
	commands := aCollection! !

!MACommandColumn methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
initialize
	super initialize.
	self commands: OrderedCollection new! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:45'!
renderCellFormContent: anObject on: html
	self commands
		do: [ :each |
			html submitButton
				callback: [ each key value: anObject ];
				text: each value ]
		separatedBy: [ html space ]! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:56'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			html anchor
				callback: [ each key value: anObject ];
				with: each value ]
		separatedBy: [ html space ]! !

MACommandColumn subclass: #MAIndexedCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAIndexedCommandColumn methodsFor: 'accessing-defaults' stamp: 'pmm 11/3/2006 20:35'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:on:index:! !

!MAIndexedCommandColumn methodsFor: 'rendering' stamp: 'pmm 1/10/2009 18:36'!
renderCellContent: anObject on: html index: anInteger
	self commands
		do: [ :each |
			html anchor
				callback: [ each key valueWithArguments: (Array
					with: anObject
					with: anInteger) ];
				with: each value ]
		separatedBy: [ html space ]! !

MAActionColumn subclass: #MASelectionColumn
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MASelectionColumn subclass: #MACheckboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultSelection
	^ Set new! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:14'!
defaultStringDeselected
	^ self webdings: 'c'! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:21'!
defaultStringSelected
	^ self webdings: 'g'! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:40'!
deselectRow: anObject
	self selection remove: anObject ifAbsent: nil! !

!MACheckboxColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSelected: anObject
	^ self selection includes: anObject! !

!MACheckboxColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:44'!
renderCellFormContent: anObject on: html
	html checkbox
		value: (self isSelected: anObject);
		callback: [ :value | self selectRow: anObject value: value ]! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:40'!
selectRow: anObject
	self selection add: anObject! !

MASelectionColumn subclass: #MAOptionboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultSelection
	^ nil! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:21'!
defaultStringDeselected
	^ self webdings: '&nbsp;'! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:20'!
defaultStringSelected
	^ self webdings: 'a'! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:41'!
deselectRow: anObject
	self selection: nil! !

!MAOptionboxColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSelected: anObject
	^ self selection == anObject! !

!MAOptionboxColumn methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
radioGroupFor: html
	"This is a very bad thing, you might never have seen in your own life. Very strange things might happen here, but for now it mostly does what we need."

	| renderer |
	renderer := self propertyAt: #radioGroupRenderer ifAbsentPut: nil.
	^ renderer == html
		ifTrue: [ self propertyAt: #radioGroupCallback ]
		ifFalse: [
			self propertyAt: #radioGroupRenderer put: html.
			self propertyAt: #radioGroupCallback put: html radioGroup ]! !

!MAOptionboxColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:44'!
renderCellFormContent: anObject on: html
	html radioButton
		group: (self radioGroupFor: html);
		selected: (self isSelected: anObject);
		callback: [ self selectRow: anObject ]! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:41'!
selectRow: anObject
	self selection: anObject! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultSelection
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:05'!
defaultStringDeselected
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/14/2008 12:05'!
defaultStringSelected
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:39'!
deselectRow: anObject
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isSelected: anObject
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
refresh
	super refresh.
	self selection: self defaultSelection! !

!MASelectionColumn methodsFor: 'rendering' stamp: 'lr 8/14/2008 12:19'!
renderCellLinkContent: anObject on: html
	| selected |
	selected := self isSelected: anObject.
	html anchor
		class: (selected isNil ifFalse: [ 'selected' ]);
		callback: [ self selectRow: anObject value: selected not ];
		with: (selected
			ifTrue: [ self stringSelected ]
			ifFalse: [ self stringDeselected ])! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:39'!
selectRow: anObject
	self subclassResponsibility! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/10/2007 09:39'!
selectRow: anObject value: aBoolean
	aBoolean
		ifTrue: [ self selectRow: anObject ]
		ifFalse: [ self deselectRow: anObject ]! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^ selection! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
selection: anObject
	selection := anObject! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 8/14/2008 12:04'!
stringDeselected
	^ self propertyAt: #stringDeselected ifAbsent: [ self defaultStringDeselected ]! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 8/14/2008 12:04'!
stringDeselected: aString
	^ self propertyAt: #stringDeselected put: aString! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 8/14/2008 12:04'!
stringSelected
	^ self propertyAt: #stringSelected ifAbsent: [ self defaultStringSelected ]! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 8/14/2008 12:04'!
stringSelected: aString
	^ self propertyAt: #stringSelected put: aString! !

!MASelectionColumn methodsFor: 'private' stamp: 'lr 8/14/2008 12:12'!
webdings: aString
	^ [ :html | html span style: 'font-family: Webdings'; with: [ html html: aString ] ]! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionComment
	^ MAStringDescription new
		accessor: #comment;
		label: 'Comment';
		priority: 200;
		yourself! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		label: 'Title';
		priority: 100;
		yourself! !

!MAColumn class methodsFor: 'instance creation' stamp: 'lr 1/26/2008 09:57'!
new
	^ self basicNew initialize! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
cascade
	^ self propertyAt: #cascade ifAbsent: [ self defaultCascade ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
cascade: anArray
	self propertyAt: #cascade put: anArray! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
column
	^ self report cache collect: [ :each | self valueFor: each ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
comment: aString
	self propertyAt: #comment put: aString! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComment
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultFooter
	^ nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:on:! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 2/12/2007 19:06'!
defaultSorter
	^[ :a :b |
		| x y |
		(x := self valueFor: a) isNil
			or: [ (y := self valueFor: b) notNil
				and: [ x <= y ] ] ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ self cascade first asCapitalizedPhrase! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultVisible
	^ true! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:33'!
exportContent: anObject index: aNumber on: aStream
	aStream nextPutAll: (anObject asString collect: [ :each |
		each isSeparator
			ifTrue: [ Character space ]
			ifFalse: [ each ] ])! !

!MAColumn methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:33'!
exportHeadOn: aStream
	self title isNil
		ifFalse: [ aStream nextPutAll: self title ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
footer
	^ self propertyAt: #footer ifAbsent: [ self defaultFooter ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
footer: aBlock
	self propertyAt: #footer put: aBlock! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
format
	^ self propertyAt: #format ifAbsent: [ self defaultFormat ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
format: aBlock
	self propertyAt: #format put: aBlock! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
index
	^ self report columns indexOf: self! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 1/26/2008 09:58'!
initialize
	properties := Dictionary new! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isReversed
	^ self report sortReversed! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSortable
	^ self report sortEnabled
		and: [ self sorter notNil ]! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSorted
	^ self report sortColumn = self! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isVisible
	^ self visible! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
properties
	^ properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol
	^ self properties at: aSymbol! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:53'!
renderCell: anObject index: anInteger on: html
	html tableData: [
		self format valueWithArguments: ((Array with: anObject with: html with: anInteger)
			first: self format numArgs) ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellContent: anObject on: html
	html render: (self valueFor: anObject)! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:53'!
renderFootCellOn: html
	html tableData: [ self renderFootContentOn: html ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 8/14/2008 11:59'!
renderHeadCellOn: html
	html tableHeading
		class: self sorterStyle;
		title: (self comment ifNil: ['']);
		with: [
			self isSortable
				ifFalse: [ self renderHeadContentOn: html ]
				ifTrue: [
					html anchor
						callback: [ self report sort: self ];
						with: [
							self renderHeadContentOn: html ] ] ]! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderHeadContentOn: html
	html render: self title! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
report
	^ report! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
selector: aSymbol
	self cascade: (Array with: aSymbol)! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setReport: aReport
	report := aReport! !

!MAColumn methodsFor: 'actions' stamp: 'nl 7/6/2006 08:43'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result
		sortBlock: self sorter;
		addAll: aCollection.
	^ self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
sorter
	^ self propertyAt: #sorter ifAbsent: [ self defaultSorter ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock! !

!MAColumn methodsFor: 'accessing' stamp: 'pmm 9/5/2007 07:26'!
sorterStyle
	^ self isSorted
		ifTrue: [
			self isReversed
				ifTrue: [ self report sorterStyles first ]
				ifFalse: [ self report sorterStyles second ] ]
		ifFalse: [ String new ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
title
	^ self propertyAt: #title ifAbsent: [ self defaultTitle ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
title: aString
	self propertyAt: #title put: aString! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
valueFor: aRow
	^ self cascade
		inject: aRow
		into: [ :result :each | result perform: each ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
visible
	^ self propertyAt: #visible ifAbsent: [ self defaultVisible ]! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/9/2006 11:33'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean! !

MAColumn subclass: #MADescribedColumn
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultCascade
	self shouldNotImplement! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 8/18/2007 10:49'!
defaultSorter
	^ self description isSortable ifTrue: [ super defaultSorter ]! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTitle
	^ self description label! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 9/26/2007 19:23'!
defaultVisible
	^ self description isVisible! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
description
	^ description! !

!MADescribedColumn methodsFor: 'exporting' stamp: 'lr 7/2/2008 09:43'!
exportContent: anObject index: aNumber on: aStream
	super exportContent: (self description toString: anObject) index: aNumber on: aStream! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderCellContent: anObject on: html
	html render: (self description toString: (self valueFor: anObject))! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
valueFor: aRow
	^ (aRow readUsing: self description)
		ifNil: [ self description default ]! !

MADescribedColumn subclass: #MADescribedComponentColumn
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedComponentColumn commentStamp: 'pmm 8/23/2006 09:43' prior: 0!
This column uses the component of a description to render the cell value.!

!MADescribedComponentColumn methodsFor: 'readme' stamp: 'pmm 8/23/2006 09:46'!
NOW
	" very experimental ... use only if you're willing to fix bugs
	  this only works for readonly views without callbacks
	  on the positive side: only one component per column is created "! !

!MADescribedComponentColumn methodsFor: 'accessing' stamp: 'pmm 8/23/2006 09:47'!
component
	component isNil ifTrue: [
		component := self description componentClass new
			setDescription: self description;
			yourself ].
	^component! !

!MADescribedComponentColumn methodsFor: 'rendering' stamp: 'pmm 8/23/2006 09:55'!
renderCellContent: anObject on: html
	self component setMemento: (anObject mementoClass
			model: anObject
			description: self description asContainer).
	self component renderViewerOn: html! !

MADescribedColumn subclass: #MADescribedScalarColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedScalarColumn methodsFor: 'rendering' stamp: 'pmm 11/3/2006 18:14'!
renderCellContent: anObject on: html
	html render: (self description reference toString: (self valueFor: anObject))! !

!MADescribedScalarColumn methodsFor: 'actions' stamp: 'pmm 11/3/2006 18:02'!
valueFor: aRow
	^aRow! !

MADescribedColumn subclass: #MAToggleColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAToggleColumn methodsFor: 'rendering' stamp: 'lr 3/28/2007 10:29'!
renderCellContent: anObject on: html
	| value |
	value := self valueFor: anObject.
	html anchor
		callback: [ anObject write: value not using: self description ];
		with: (self description toString: value)! !

!Object methodsFor: '*magritte-seaside-converting' stamp: 'lr 3/9/2006 11:33'!
asComponent
	^ self description asComponentOn: self! !

WAComponent subclass: #MAComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Core'!

MAComponent subclass: #MAColorChooser
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Core'!

!MAColorChooser commentStamp: '<historical>' prior: 0!
MAColorComponent use me to display a beautiful palette!

!MAColorChooser class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
color: aColor
	^ self new
		color: aColor;
		yourself! !

!MAColorChooser class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
cancel
	self answer: nil! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
color
	^ color! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
color: aColor
	color := aColor! !

!MAColorChooser methodsFor: 'accessing-dynamic' stamp: 'lr 12/1/2006 13:56'!
palette
	^ Color oldColorPaletteForDepth: 16 extent: 200 @ 100! !

!MAColorChooser methodsFor: 'rendering' stamp: 'lr 7/14/2007 09:01'!
renderContentOn: html
	html map
		callback: [ :point | self answer: (self palette colorAt: point) ];
		with: [ html image form: self palette ]! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
save
	self answer: self color! !

!MAComponent class methodsFor: 'accessing' stamp: 'lr 8/14/2006 10:41'!
description
	^ MADescriptionBuilder for: self! !

!MAComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ true! !

!MAComponent class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:34'!
new
	"Create a new instance of the receiving component class and checks if it is not abstract."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new! !

!MAComponent class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:34'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MAComponent class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:34'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
ajaxId
	^ self ajaxId: String new! !

!MAComponent methodsFor: 'accessing' stamp: 'sebh 6/15/2009 12:17'!
ajaxId: aSymbol
	^ String streamContents: [ :stream |
		stream
			nextPutAll: 'field';
			nextPutAll: (self description label reject: [:aChar | aChar = $ .]).
		]! !

!MAComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isMultipart
	^ self children anySatisfy: [ :each | each isMultipart ]! !

MAComponent subclass: #MADescriptionComponent
	instanceVariableNames: 'memento description parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADescriptionComponent commentStamp: '<historical>' prior: 0!
I'm a seaside object which provides all the functions for my subclasses to display MADescription subclasses.!

MADescriptionComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children readonly errors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addForm
	self addForm: #( save cancel )! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection)! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addSwitch
	self addDecoration: MASwitchDecoration new.
	self readonly: true! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addValidatedForm
	self addForm; addValidation! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addValidatedForm: aCollection
	self addForm: aCollection; addValidation! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addValidatedSwitch
	self addSwitch; addValidation! !

!MAContainerComponent methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addValidation
	self addDecoration: MAValidationDecoration new! !

!MAContainerComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildChildren
	^ self description
		inject: Dictionary new
		into: [ :result :each |
			each isVisible ifTrue: [
				result at: each put: (each componentClass
					memento: self memento description: each parent: self) ].
			result ]! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
cancel
	self reset; answer: nil! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
childAt: aDescription
	^ children at: aDescription ifAbsent: [ nil ]! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
children
	^ children values! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 9/21/2008 09:45'!
commit
	self memento commit! !

!MAContainerComponent methodsFor: 'private' stamp: 'lr 9/21/2008 10:23'!
doValidate
	self memento validate.
	self children do: [ :each | each doValidate ]! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
edit
	self readonly: false! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 9/12/2007 17:26'!
errors
	"Answer a collection of exceptions, the list of standing errors."

	^ errors! !

!MAContainerComponent methodsFor: 'initialization' stamp: 'lr 4/20/2007 13:07'!
initialize
	super initialize.
	errors := OrderedCollection new! !

!MAContainerComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isReadonly
	^ super isReadonly or: [ self readonly ]! !

!MAContainerComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
readonly
	^ readonly ifNil: [ readonly := false ]! !

!MAContainerComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
readonly: aBoolean
	readonly := aBoolean! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 4/20/2007 13:07'!
renderContentOn: html
	self description componentRenderer
		component: self on: html! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 9/21/2008 09:45'!
reset
	self memento reset! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/20/2007 13:13'!
save
	self validate ifFalse: [ ^ self ].
	self commit; answer: self model! !

!MAContainerComponent methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setChildren: aDictionary
	children := aDictionary! !

!MAContainerComponent methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	super setDescription: aDescription.
	self setChildren: self buildChildren! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 9/21/2008 10:23'!
validate
	errors := OrderedCollection new.
	[ self doValidate ]
		on: MAError
		do: [ :error |
			errors add: error.
			error isResumable
				ifTrue: [ error resume ] ].
	^ errors isEmpty! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
memento: aMemento
	^ self memento: aMemento description: aMemento description! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
memento: aMemento description: aDescription
	^ self memento: aMemento description: aDescription parent: nil! !

!MADescriptionComponent class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		yourself! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 1/10/2008 16:23'!
attributes
	self deprecatedApi: '#attributes is not supported anymore.'.
	^ WAHtmlAttributes new! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
description
	^ description! !

!MADescriptionComponent methodsFor: 'private' stamp: 'lr 9/21/2008 10:23'!
doValidate
	"Enables components to raise errors when the model is validated."! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
id
	^ self class name asLowercase , self hash asString! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isReadonly
	^ self description isReadonly
		or: [ self isRoot not
		and: [ self parent isReadonly ] ]! !

!MADescriptionComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isRoot
	^ self parent isNil! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 9/12/2007 17:26'!
labelId
	"Accessor that returns the an id that can be reference by a <label>-tag."

	^ self ajaxId: 'label'! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
memento
	^ memento! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
model
	^ self memento model! !

!MADescriptionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
parent
	^ parent! !

!MADescriptionComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
root
	^ self isRoot
		ifTrue: [ self ]
		ifFalse: [ self parent root ]! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	description := aDescription! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionComponent methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setParent: aComponent
	parent := aComponent! !

MADescriptionComponent subclass: #MAElementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAElementComponent commentStamp: '<historical>' prior: 0!
I provide a basic display for all subclasses of MAElementDescription (only for readonly descriptions). The object is just displayed as a string. For more complex behaviour, overried #renderViewerOn:. !

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent commentStamp: '<historical>' prior: 0!
I'm a seaside component used to display MABooleanDescription. If I'm writeable (readonly property of my description to false) I display a checkbox otherwise, I display a string: 'yes' if true, 'no' if false', '' if nil.!

!MACheckboxComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MACheckboxComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:42'!
renderEditorOn: html
	html label: [
		html checkbox
			id: self labelId;
			disabled: self isReadonly;
			on: #value of: self.
		html space; render: self description checkboxLabel ]! !

MAElementComponent subclass: #MAColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAColorComponent commentStamp: '<historical>' prior: 0!
Seaside component of MAColorDescription. I display a little box with the current selected color. If you click on the box, a beautiful palette will be displayed thanks to MAColorChooser.!

!MAColorComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAColorComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
choose
	self chooser: (MAColorChooser color: self value)! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
form
	| form |
	form := Form extent: self width @ self height depth: 32.
	form getCanvas
		drawPolygon: (Array with: 0 @ self height with: 0 @ 0 with: self width @ 0)
			color: Color white borderWidth: 0 borderColor: Color white;
		drawPolygon: (Array with: 0 @ self height with: self width @ self height with: self width @ 0)
			color: Color black borderWidth: 0 borderColor: Color white;
		fillRectangle: (0 @ 0 extent: self width @ self height)
			color: self value.
	^ form! !

!MAColorComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
height
	^ 15! !

!MAColorComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:01'!
renderEditorOn: html
	html imageButton
		id: self labelId;
		callback: [ self choose ];
		attributeAt: 'width' put: self width;
		attributeAt: 'height' put: self height;
		attributeAt: 'src' put: (html context urlForDocument: self form)! !

!MAColorComponent methodsFor: 'rendering' stamp: 'pmm 12/15/2006 17:00'!
renderViewerOn: html
	html image
		id: self labelId;
		form: self form! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
value
	^ super value ifNil: [ self description kind transparent ]! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
width
	^ 30! !

!MAElementComponent methodsFor: 'calling' stamp: 'lr 3/9/2006 11:33'!
chooser: aComponent
	self chooser: aComponent titled: 'Edit ' , self description label! !

!MAElementComponent methodsFor: 'calling' stamp: 'lr 3/9/2006 11:33'!
chooser: aComponent titled: aString
	| result |
	result := self root call: (aComponent
		addMessage: aString;
		yourself).
	result isNil
		ifFalse: [ self value: result ]! !

!MAElementComponent methodsFor: 'testing' stamp: 'lr 9/12/2007 17:27'!
hasLabelId
	"Return whether somewhere an element is rendered with the id ==labelId== that can be reference by a <label>-tag."

	^ false! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
reference
	^ self description reference! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderContentOn: html
	self isReadonly
		ifTrue: [ self renderViewerOn: html ]
		ifFalse: [ self renderEditorOn: html ]! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderEditorOn: html
	self renderViewerOn: html! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderViewerOn: html
	html render: self string! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 3/27/2006 11:42'!
string
	^ self value isString
		ifTrue: [ self value ]
		ifFalse: [ self description toString: self value ]! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 3/9/2006 11:33'!
string: aString
	| value |
	value := [ self description fromString: aString ]
		ifError: [ aString ].
	self value: value! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 3/9/2006 11:33'!
value
	^ self memento readUsing: self description! !

!MAElementComponent methodsFor: 'accessing-model' stamp: 'lr 3/9/2006 11:33'!
value: anObject
	self memento write: anObject using: self description! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent commentStamp: '<historical>' prior: 0!
I'm the MAFileDescription seaside component. With me user can upload files to the server. I provide a button for the user to browse their computer for files.!

!MAFileUploadComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAFileUploadComponent methodsFor: 'testing' stamp: 'lr 1/26/2007 18:38'!
hasLabelId
	^ self isReadonly not and: [ self isMultipart ]! !

!MAFileUploadComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isMultipart
	^ self value isNil or: [ self value isEmpty ]! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 9/30/2007 18:31'!
remove
	self value ifNotNil: [ self value finalize ].
	self value: nil! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderEditorOn: html
	self isMultipart
		ifTrue: [ self renderUploadOn: html ]
		ifFalse: [ self renderRemoveOn: html ]! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 1/26/2007 18:54'!
renderRemoveOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	html submitButton on: #remove of: self! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderUploadOn: html
	html fileUpload
		id: self labelId;
		on: #upload of: self.
	html submitButton
		text: 'upload'! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 1/26/2007 18:50'!
renderViewerOn: html
	html render: self value! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 1/26/2007 18:38'!
upload: aFile
	self value: (aFile isNil ifFalse: [
		self description kind new
			mimetype: aFile contentType;
			filename: aFile fileName;
			contents: aFile contents;
			yourself ])! !

MAElementComponent subclass: #MAOptionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAOptionComponent subclass: #MAMultipleSelectionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAMultipleSelectionComponent commentStamp: '<historical>' prior: 0!
I provide basic functionalities for MAListCompositionComponent and MACheckboxGroupComponent.!

MAMultipleSelectionComponent subclass: #MACheckboxGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxGroupComponent commentStamp: '<historical>' prior: 0!
Use for MAMultipleSelectionComponent. I display as many checkboxes as my description has options. Another representation for the same description is MAListCompositionComponent.!

!MACheckboxGroupComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MACheckboxGroupComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly! !

!MACheckboxGroupComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isDistinct
	^ true! !

!MACheckboxGroupComponent methodsFor: 'private' stamp: 'pmm 12/21/2006 22:41'!
optionId: anInteger
	^self ajaxId: 'option', anInteger displayString! !

!MACheckboxGroupComponent methodsFor: 'private' stamp: 'pmm 12/21/2006 22:41'!
optionsWithIndexDo: elementAndIndexBlock separatedBy: separatorBlock
	| index |
	index := 1.
	self description allOptions
		do: [ :each |
			elementAndIndexBlock value: each value: index.
			index := index + 1 ]
		separatedBy: separatorBlock! !

!MACheckboxGroupComponent methodsFor: 'rendering' stamp: 'lr 6/28/2008 11:00'!
renderEditorOn: html
	html hiddenInput 
		callback: [ :value | self clear ].
	self
		optionsWithIndexDo: [ :each :index |
			| optionId |
			optionId := self optionId: index.
			html checkbox
				id: optionId;
				value: (self selectedList includes: each);
				onTrue: [ self add: each ] 
				onFalse: [ self remove: each ].
			html space.
			html label
				for: optionId;
				with: (self labelForOption: each) ]
		separatedBy: [ html break ]! !

MAMultipleSelectionComponent subclass: #MAListCompositonComponent
	instanceVariableNames: 'availableSelected selectedSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAListCompositonComponent commentStamp: '<historical>' prior: 0!
I'm, like MACheckboxComponent, a seaside component for MAMultipleSelectionDescription. I display two lists. In the first, all available options, in the other, what the user selected. 2 buttons in between to add and remove elements to/from the selected list. If the everything property is set, I display two more buttons to allow the user to add or remove all options in one click.!

!MAListCompositonComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'kph 1/31/2008 23:56'!
add
	| added |
	self availableSelected isNil
		ifTrue: [ ^ self ].
	added := (self availableSelected copy).
	self add: added.
	self selectedSelected: added.
	self description isDistinct
		ifTrue: [ self availableSelected: nil ]! !

!MAListCompositonComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
availableList
	^ self description isDistinct
		ifFalse: [ super availableList ]
		ifTrue: [ super availableList copyWithoutAll: self selectedList ]! !

!MAListCompositonComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
availableSelected
	^ availableSelected! !

!MAListCompositonComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
availableSelected: anObject
	availableSelected := anObject! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
moveDown
	self selectedSelected isNil
		ifFalse: [ self selectedList moveDown: self selectedSelected ]! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
moveUp
	self selectedSelected isNil
		ifFalse: [ self selectedList moveUp: self selectedSelected ]! !

!MAListCompositonComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
remove
	self selectedSelected isNil
		ifTrue: [ ^ self ].
	self remove: self selectedSelected.
	self availableSelected: self selectedSelected.
	self selectedSelected: nil! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 1/10/2008 16:03'!
renderEditorAvailableOn: html
	html select
		size: 6; 
		style: 'width: 150px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponent methodsFor: 'rendering-buttons' stamp: 'lr 3/9/2006 11:33'!
renderEditorButtonAddOn: html
	html submitButton
		callback: [ self add ];
		text: '>>'.
	html break.
	html submitButton
		callback: [ self remove ];
		text: '<<'! !

!MAListCompositonComponent methodsFor: 'rendering-buttons' stamp: 'lr 3/9/2006 11:33'!
renderEditorButtonOrderOn: html
	html submitButton
		callback: [ self moveUp ];
		text: 'up'.
	html break.
	html submitButton
		callback: [ self moveDown ];
		text: 'down'! !

!MAListCompositonComponent methodsFor: 'rendering' stamp: 'lr 4/10/2008 14:04'!
renderEditorOn: html 
	html table id: self labelId; with: [
		html tableRow: [
			html tableData: [ self renderEditorAvailableOn: html ].
			html tableData 
				style: 'vertical-align: center';
				with: [ self renderEditorButtonAddOn: html ].
			html tableData: [ self renderEditorSelectedOn: html ].
			self isOrdered ifTrue: [
				html tableData 
					style: 'vertical-align: center';
					with: [ self renderEditorButtonOrderOn: html ] ] ] ]! !

!MAListCompositonComponent methodsFor: 'rendering-parts' stamp: 'lr 1/10/2008 16:03'!
renderEditorSelectedOn: html
	html select
		size: 6; 
		style: 'width: 150px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
selectedSelected
	^ selectedSelected! !

!MAListCompositonComponent methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:33'!
selectedSelected: anObject
	selectedSelected := anObject! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
add: anObject
	(self isDistinct and: [ self value includes: anObject ])
		ifFalse: [ self value: (self value copyWith: anObject) ]! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
availableList
	^ self description allOptions! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 6/28/2008 10:59'!
clear
	self value: self value copyEmpty! !

!MAMultipleSelectionComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MAMultipleSelectionComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isDistinct
	^ self description isDistinct! !

!MAMultipleSelectionComponent methodsFor: 'testing' stamp: 'lr 2/16/2007 08:49'!
isOrdered
	^ self description isOrdered
		and: [ (self value respondsTo: #moveUp:)
		and: [ self value respondsTo: #moveDown: ] ]! !

!MAMultipleSelectionComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
remove: anObject
	self value: (self isDistinct
		ifTrue: [ self value copyWithout: anObject ]
		ifFalse: [ self value copyWithoutFirst: anObject ])! !

!MAMultipleSelectionComponent methodsFor: 'rendering' stamp: 'lr 4/12/2007 19:33'!
renderViewerOn: html
	html unorderedList
		id: self labelId;
		list: self selectedList;
		labels: [ :each | self labelForOption: each ]! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selectedList
	^ self value! !

!MAMultipleSelectionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
value
	^ super value ifNil: [ self value: Array new. super value ]! !

MAMultipleSelectionComponent subclass: #MAMultiselectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAMultiselectListComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAMultiselectListComponent methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isDistinct
	^ true! !

!MAMultiselectListComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderEditorOn: html
	html multiSelect
		size: 8;
		id: self labelId;
		list: self availableList;
		selected: self selectedList;
		labels: [ :value | self labelForOption: value ];
		callback: [ :value | self value: value ]! !

!MAOptionComponent methodsFor: 'private' stamp: 'lr 4/12/2007 19:33'!
labelForOption: anObject
	^ self description labelForOption: anObject! !

MAOptionComponent subclass: #MASingleSelectionComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MASingleSelectionComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent commentStamp: '<historical>' prior: 0!
I display a set of radio buttons to render MASingleSelectionDescription.!

!MARadioGroupComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MARadioGroupComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly not! !

!MARadioGroupComponent methodsFor: 'private' stamp: 'pmm 12/21/2006 22:31'!
optionId: anInteger
	^self ajaxId: 'option', anInteger displayString! !

!MARadioGroupComponent methodsFor: 'private' stamp: 'pmm 12/21/2006 22:37'!
optionsWithIndexDo: elementAndIndexBlock separatedBy: separatorBlock
	| index |
	index := 1.
	self options
		do: [ :each |
			elementAndIndexBlock value: each value: index.
			index := index + 1 ]
		separatedBy: separatorBlock! !

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'pmm 1/8/2007 11:12'!
renderEditorOn: html
	| group |
	group := html radioGroup.
	html span
		id: self labelId;
		with: [
			self
				optionsWithIndexDo: [ :each :index |
					self
						renderOption: each
						index: index
						in: group
						on: html ]
				separatedBy: [ html break ] ]! !

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderOption: anObject index: anInteger in: aRadioGroup on: html
	| optionId |
	optionId := self optionId: anInteger.
	html radioButton
		id: optionId;
		group: aRadioGroup;
		selected: self value = anObject;
		callback: [ self value: anObject ].
	html space.
	html label
		for: optionId;
		with: (self labelForOption: anObject)! !

MASingleSelectionComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent commentStamp: '<historical>' prior: 0!
I display a simple list to allow the user to choose one element from the list. I am one of the two seaside components to render MASingleSelectionDescription.!

!MASelectListComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MASelectListComponent methodsFor: 'accessing-model' stamp: 'lr 9/21/2008 10:40'!
groups
	"The options objects are assumed to understand the 'groupBy' selector supplied by the description object. Keep the global ordering intact."

	| groups group |
	groups := OrderedCollection new.
	self options do: [ :option | 
		option isNil ifFalse: [
			group := self description groupBy read: option.
			(groups
				detect: [ :each | each key = group ]
				ifNone: [ groups addLast: group -> OrderedCollection new ])
					value addLast: option ] ].
	^ groups! !

!MASelectListComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly not! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 8/14/2008 11:58'!
renderEditorForGroupedOn: html 
	html select 
		id: self labelId;
		selected: self value;
		callback: [ :value | self value: value ];
		with: [ self renderGroupsOn: html ]! !

!MASelectListComponent methodsFor: 'rendering' stamp: 'sebh 6/3/2009 20:12'!
renderEditorForUngroupedOn: html
	html select
		id: self labelId;
		list: self options;
		selected: self value;
		callback: [ :value | self value: value ];
		labels: [ :value | self labelForOption: value ]! !

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 4/29/2008 17:05'!
renderEditorOn: html
	self description isGrouped
		ifTrue: [ self renderEditorForGroupedOn: html ]
		ifFalse: [ self renderEditorForUngroupedOn: html ]
! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 9/3/2008 11:41'!
renderGroupsOn: html
	^ self groups do: [ :association |
		html optionGroup
			label: association key;
			with: [ 
				association value
					do: [ :option | self renderOption: option on: html ] ] ]! !

!MASelectListComponent methodsFor: 'rendering-grouped' stamp: 'lr 4/29/2008 17:05'!
renderOption: option on: html
	^ html option
		selected: self value = option;
		label: (self labelForOption: option);
		callback: [ self value: option ];
		with: option! !

!MASingleSelectionComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
options
	^ self description allOptionsWith: self value! !

!MASingleSelectionComponent methodsFor: 'rendering' stamp: 'lr 4/29/2008 17:04'!
renderViewerOn: html
	html render: (self labelForOption: self value)! !

MAElementComponent subclass: #MARangeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARangeComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MARangeComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly not! !

!MARangeComponent methodsFor: 'accessing' stamp: 'lr 4/20/2007 13:38'!
labelId
	^ self id! !

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
max
	^ self description max ifNil: [ 100 ]! !

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
min
	^ self description min ifNil: [ -100 ]! !

!MARangeComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
range
	^ self max - self min! !

!MARangeComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderEditorOn: html
	html rangeInput
		id: self id;
		onInput: self updateScript;
		min: 0; "default"
		max: 100; "default"
		on: #string of: self.
	html span id: self id , 'v'.
	html script: self updateScript! !

!MARangeComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
updateScript
	^ String streamContents: [ :stream |
		stream
			nextPutAll: 'document.getElementById('; print: self id , 'v';
			nextPutAll: ').innerHTML = document.getElementById('; print: self id;
			nextPutAll: ').value * ('; print: self range;
			nextPutAll: ') / 100 + ('; print: self min;
			nextPutAll: ');' ]! !

!MARangeComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
value
	^ ((super value ifNil: [ 0 ]) - self min) * 100 / self range! !

!MARangeComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
value: aNumber
	super value: (aNumber ifNotNil: [ aNumber * self range / 100 + self min ])! !

MAElementComponent subclass: #MARelationComponent
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MARelationComponent subclass: #MAOneToManyComponent
	instanceVariableNames: 'report commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOneToManyComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
add
	| result |
	result := self selected new.
	result := self root call: (result asComponent
		addMessage: 'Add ' , self selected label;
		addValidatedForm;
		yourself).
	result isNil
		ifFalse: [ self value: (self value copyWith: result); refresh ]! !

!MAOneToManyComponent methodsFor: 'private' stamp: 'lr 3/18/2008 23:03'!
buildCommands
	commands := MACommandColumn new setReport: self report.
	self description isDefinitive ifFalse: [
		commands
			addCommandOn: self selector: #edit: text: 'edit';
			addCommandOn: self selector: #remove: text: 'remove' ].
	self description isOrdered ifTrue: [
		commands
			addCommandOn: self selector: #up: text: 'up';
			addCommandOn: self selector: #down: text: 'down' ].
	^ commands! !

!MAOneToManyComponent methodsFor: 'private' stamp: 'lr 3/18/2008 23:01'!
buildReport
	^ (MAReport rows: self value description: self reference)
		sortEnabled: self description isOrdered not;
		yourself! !

!MAOneToManyComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
children
	^ Array with: self report! !

!MAOneToManyComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
commands
	^ commands ifNil: [ commands := self buildCommands ]! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'dc 4/15/2006 15:08'!
down: anElement
	self value moveDown: anElement! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
edit: anObject
	self root call: (anObject asComponent
		addMessage: 'Edit ' , self selected label;
		addValidatedForm;
		yourself).
	self refresh! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
refresh
	self report rows: self value! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
remove: anObject
	self value: (self value copyWithout: anObject).
	self refresh! !

!MAOneToManyComponent methodsFor: 'rendering' stamp: 'lr 3/18/2008 22:55'!
renderEditorOn: html
	self renderViewerOn: html.
	self description isDefinitive
		ifFalse: [ self renderSelectListOn: html ]! !

!MAOneToManyComponent methodsFor: 'rendering-buttons' stamp: 'sebh 6/14/2009 17:49'!
renderSelectButtonOn: html
	html submitButton on: #add of: self; id: 'button', self description label, 'Add'! !

!MAOneToManyComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderViewerOn: html
	| columns |
	columns := self report columns
		copyWithout: self commands.
	self report columns: (self isReadonly
		ifFalse: [ columns copyWith: self commands ]
		ifTrue: [ columns ]).
	html render: self report! !

!MAOneToManyComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
report
	^ report ifNil: [ report := self buildReport ]! !

!MAOneToManyComponent methodsFor: 'actions' stamp: 'dc 4/15/2006 15:08'!
up: anElement
	self value moveUp: anElement! !

MAOneToManyComponent subclass: #MAOneToManyScalarComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOneToManyScalarComponent methodsFor: 'actions' stamp: 'lr 8/14/2008 12:24'!
add
	| holder holderDescription |
	holder := MAValueHolder new.
	holderDescription := self reference copy
		accessor: (MASelectorAccessor selector: #contents);
		yourself.
	holder := self root call: ((holderDescription asContainer asComponentOn: holder)
		addMessage: 'Add ' , self selected label;
		addValidatedForm;
		yourself).
	holder isNil
		ifFalse: [ self value: (self value copyWith: holder contents); refresh ]! !

!MAOneToManyScalarComponent methodsFor: 'private' stamp: 'lr 2/12/2007 19:06'!
buildCommands
	commands := MAIndexedCommandColumn new
				setReport: self report.

	self description isDefinitive
		ifFalse: [ commands
					addCommandOn: self selector: #edit:index: text: 'Edit';
					addCommandOn: self selector: #remove:index: text: 'Remove'].
	"not yet implemented
	self description isOrdered
		ifTrue: [ commands
					addCommandOn: self selector: #up:index:;
					addCommandOn: self selector: #down:index: ]. "

	^ commands! !

!MAOneToManyScalarComponent methodsFor: 'private' stamp: 'pmm 11/3/2006 18:07'!
buildReport
	^ MAReport rows: self value description: self description! !

!MAOneToManyScalarComponent methodsFor: 'actions' stamp: 'lr 8/14/2008 12:24'!
edit: anObject index: anInteger 
	"sorry, but a collection might include duplicates like #(1 2 1) and you only want to edit the one with the correct index"
	| holder holderDescription |
	holder := MAValueHolder on: anObject.
	holderDescription := self reference copy
		accessor: (MASelectorAccessor selector: #contents);
		yourself.
	holder := self root call: ((holderDescription asContainer asComponentOn: holder)
			addMessage: 'Edit ' , self selected label;
			addValidatedForm;
			yourself).
	holder isNil ifTrue: [ ^ self ].
	self value: (self value isSequenceable 
			ifTrue: 
				[ self copy value
					at: anInteger
						put: holder contents;
					yourself ]
			ifFalse: 
				[ self value copy
					remove: anObject;
					add: holder contents;
					yourself ]).
	self refresh! !

!MAOneToManyScalarComponent methodsFor: 'actions' stamp: 'pmm 11/3/2006 20:51'!
remove: anObject index: anInteger
	"sorry, but a collection might include duplicates like #(1 2 1) and you only want to remove the one with the correct index"
	self value: (self value isSequenceable
		ifTrue: [ self value copyWithoutIndex: anInteger ]
		ifFalse: [ self value copyWithout: anObject ]).
	self refresh! !

MARelationComponent subclass: #MAOneToOneComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAOneToOneComponent subclass: #MAExternalEditorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAExternalEditorComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAExternalEditorComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
create
	self chooser: (self editorFor: self selected new)! !

!MAExternalEditorComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
edit
	self chooser: (self editorFor: self value)! !

!MAExternalEditorComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderButtonsOn: html
	html submitButton on: #remove of: self.
	html submitButton on: #edit of: self! !

!MAExternalEditorComponent methodsFor: 'rendering' stamp: 'lr 4/29/2008 17:21'!
renderViewerOn: html
	html render: (self reference toString: self value)! !

MAOneToOneComponent subclass: #MAInternalEditorComponent
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAInternalEditorComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAInternalEditorComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildComponent
	^ self value asComponent
		setParent: self;
		yourself! !

!MAInternalEditorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
children
	^ Array with: self component! !

!MAInternalEditorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!MAInternalEditorComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
create
	self value: self selected new.
	component := nil! !

!MAInternalEditorComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderEditorOn: html
	super renderEditorOn: html.
	html hiddenInput callback: [ self component commit ]! !

!MAInternalEditorComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderViewerOn: html
	html render: (self component
		readonly: self isReadonly;
		yourself)! !

!MAOneToOneComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
create
	self subclassResponsibility! !

!MAOneToOneComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
remove
	self value: nil! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderButtonsOn: html! !

!MAOneToOneComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderEditorOn: html
	self value isNil
		ifTrue: [ self renderSelectListOn: html ]
		ifFalse: [ self renderViewerOn: html; renderButtonsOn: html ]! !

!MAOneToOneComponent methodsFor: 'rendering-tools' stamp: 'lr 3/9/2006 11:33'!
renderSelectButtonOn: html
	html submitButton on: #create of: self! !

!MARelationComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
classes
	^ self description classes! !

!MARelationComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
editorFor: anObject
	^ anObject asComponent
		addValidatedForm;
		yourself! !

!MARelationComponent methodsFor: 'rendering-tools' stamp: 'lr 3/9/2006 11:33'!
renderSelectButtonOn: html
	self subclassResponsibility! !

!MARelationComponent methodsFor: 'rendering-tools' stamp: 'sebh 6/3/2009 20:14'!
renderSelectListOn: html
	self classes size > 1 ifTrue: [
		html select
			list: self classes;
			selected: self selected;
			callback: [ :value | self selected: value ];
			labels: [ :value | value label ] ].
	self classes notEmpty
		ifTrue: [ self renderSelectButtonOn: html ]! !

!MARelationComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected
	^ selected ifNil: [ selected := self classes first ]! !

!MARelationComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected: aClass
	selected := aClass! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'descriptionTable componentTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
buildComponentTable
	^ self descriptionTable collect: [ :row :col :each |
		each componentClass
			memento: self
			description: each
			parent: self ]! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
buildDataTable
	^ MATableModel
		rows: self description rowCount
		columns: self description columnCount! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
buildDescriptionTable
	^ self dataTable collect: [ :row :col :each |
		self description reference copy
			accessor: MANullAccessor new;
			label: row asString , '/' , col asString;
			propertyAt: #row put: row;
			propertyAt: #column put: col;
			yourself ]! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:34'!
children
	^ self componentTable contents! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
componentTable
	^ componentTable ifNil: [ componentTable := self buildComponentTable ]! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
dataTable
	self value isNil
		ifTrue: [ self value: self buildDataTable ]
		ifFalse: [
			(self value rowCount = self description rowCount
				and: [ self value columnCount = self description columnCount ]) ifFalse: [
					self value: (self value
						copyRows: self description rowCount
						columns: self description columnCount) ] ].
	^ self value! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:34'!
descriptionTable
	^ descriptionTable ifNil: [ descriptionTable := self buildDescriptionTable ]! !

!MATableComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
readUsing: aDescription
	^ self dataTable
		at: (aDescription propertyAt: #row)
		at: (aDescription propertyAt: #column)! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 4/10/2008 14:05'!
renderViewerOn: html 
	html table
		id: self labelId;
		with: 
			[ html tableRow: 
				[ html tableHeading: nil.
				self description columnLabels do: [ :each | html tableHeading: each ] ].
			self description rowLabels keysAndValuesDo: 
				[ :rindex :row | 
				html tableRow: 
					[ html tableHeading: row.
					self description columnLabels keysAndValuesDo: 
						[ :cindex :col | 
						html tableData: (self componentTable 
								uncheckedAt: rindex
								at: cindex) ] ] ] ]! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
write: anObject using: aDescription
	^ self dataTable
		at: (aDescription propertyAt: #row)
		at: (aDescription propertyAt: #column)
		put: anObject! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent commentStamp: 'lr 2/3/2007 23:12' prior: 0!
I display an html text area for the magritte MAMemoDescription.!

!MATextAreaComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MATextAreaComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly not! !

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderEditorOn: html
	html textArea
		id: self labelId;
		rows: self description lineCount;
		on: #string of: self! !

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:34'!
renderViewerOn: html
	(self string findTokens: Character cr)
		do: [ :each | html render: each ]
		separatedBy: [ html break ]! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextInputComponent commentStamp: '<historical>' prior: 0!
I'm a simple input box for MAStringDescription.!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
choose
	| calendar |
	calendar := WAMiniCalendar new.
	calendar
		date: ((self value notNil
			and: [ self description isSatisfiedBy: self value ])
				ifFalse: [ Date current ]
				ifTrue: [ self value ]);
		selectBlock: [ :value | calendar answer: value ];
		canSelectBlock: [ :value | self description isSatisfiedBy: value ].
	self chooser: calendar! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:06'!
renderButtonOn: html
	html submitButton on: #choose of: self! !

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 9/21/2008 10:03'!
today
	| calendar |
	calendar := WAMiniCalendar new.
	calendar
		date: ((self value notNil
			and: [ self description isSatisfiedBy: self value ])
				ifFalse: [ Date current ]
				ifTrue: [ self value ]);
		selectBlock: [ :value | calendar answer: value ];
		canSelectBlock: [ :value | self description isSatisfiedBy: value ].
	self chooser: calendar! !

MADateInputComponent subclass: #MADateSelectorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateSelectorComponent class methodsFor: 'testing' stamp: 'pmm 10/22/2006 07:57'!
isAbstract
	^false! !

!MADateSelectorComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:06'!
renderButtonOn: html! !

!MADateSelectorComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:05'!
renderInputOn: html
	html dateInput
		value: self value;
		callback: [ :value | self value: value ]! !

!MATextInputComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MATextInputComponent methodsFor: 'testing' stamp: 'lr 3/9/2007 14:44'!
hasLabelId
	^ self isReadonly not! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 09:59'!
renderButtonOn: html! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 09:58'!
renderEditorOn: html
	self renderInputOn: html.
	self renderButtonOn: html! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'sebh 6/14/2009 16:58'!
renderInputOn: html
	html textInput
		id: self labelId;
		on: #string of: self! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'actions' stamp: 'lr 9/21/2008 10:07'!
now
	self value: Time now! !

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:07'!
renderButtonOn: html
	html submitButton on: #now of: self! !

MATimeInputComponent subclass: #MATimeSelectorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeSelectorComponent class methodsFor: 'testing' stamp: 'pmm 10/22/2006 07:48'!
isAbstract
	^false! !

!MATimeSelectorComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:09'!
renderInputOn: html
	html timeInput
		withSeconds;
		value: self value;
		callback: [ :value | self value: value ]! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
current
	self value: TimeStamp current! !

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 9/21/2008 10:01'!
renderButtonOn: html
	html submitButton on: #current of: self! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent commentStamp: '<historical>' prior: 0!
Password seaside component, I display stars '*' instead of the text typed by the user. My description is MAPasswordDescription.!

!MATextPasswordComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MATextPasswordComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ self isReadonly not! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:02'!
renderEditorOn: html
	html passwordInput
		id: self labelId;
		on: #string of: self! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 11/14/2008 09:58'!
string
	^ self description obfuscated: super string! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 9/21/2007 13:21'!
string: aString
	(self description isObfuscated: aString)
		ifFalse: [ super string: aString ]! !

MATextPasswordComponent subclass: #MAVerifiedPasswordComponent
	instanceVariableNames: 'verificationValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAVerifiedPasswordComponent methodsFor: 'private' stamp: 'lr 11/14/2008 11:01'!
doValidate
	self value = verificationValue
		ifFalse: [ ^ MAConditionError description: self description signal: 'Your passwords do not match' ].
	super doValidate! !

!MAVerifiedPasswordComponent methodsFor: 'rendering' stamp: 'lr 11/14/2008 10:59'!
renderEditorOn: html
	super renderEditorOn: html.
	html break.
	html passwordInput
		class: 'verification';
		on: #verificationString of: self! !

!MAVerifiedPasswordComponent methodsFor: 'initialization' stamp: 'lr 11/14/2008 11:36'!
setDescription: aDescription
	super setDescription: aDescription.
	self verificationValue: self value! !

!MAVerifiedPasswordComponent methodsFor: 'accessing' stamp: 'lr 11/14/2008 10:33'!
verificationString
	^ self description obfuscated: self verificationValue! !

!MAVerifiedPasswordComponent methodsFor: 'accessing' stamp: 'lr 11/14/2008 11:00'!
verificationString: aString
	| value |
	(self description isObfuscated: aString)
		ifTrue: [ ^ self ].
	value := [ self description fromString: aString ]
		ifError: [ aString ].
	self verificationValue: value! !

!MAVerifiedPasswordComponent methodsFor: 'accessing' stamp: 'lr 11/14/2008 11:02'!
verificationValue
	^ verificationValue! !

!MAVerifiedPasswordComponent methodsFor: 'accessing' stamp: 'lr 11/14/2008 10:05'!
verificationValue: anObject
	verificationValue := anObject! !

MAElementComponent subclass: #MAUndefinedComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAUndefinedComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAUndefinedComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MAUndefinedComponent methodsFor: 'rendering' stamp: 'pmm 12/15/2006 17:17'!
renderContentOn: html
	html span
		id: self labelId;
		style: 'color: red;';
		with: 'Undefined Component'! !

MADescriptionComponent subclass: #MAReportComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAReportComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAReportComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MAReportComponent methodsFor: 'rendering' stamp: 'lr 3/10/2007 09:48'!
renderContentOn: html
	html table id: self labelId; with: [
		self renderTableCaptionOn: html.
		self renderTableSummaryOn: html.
		self renderTableHeadOn: html.
		self renderTableFootOn: html.
		self renderTableBodyOn: html ]! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 8/13/2008 23:47'!
renderTableBodyOn: html
	(html tag: 'tbody') with: [
		self description showBody ifTrue: [
			(self value isNil or: [ self value isEmpty ])
				ifTrue: [ self renderTableEmptyOn: html ]
				ifFalse: [ self renderTableContentOn: html ] ] ]! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 8/14/2008 00:22'!
renderTableCaptionOn: html
	self description caption isNil ifFalse: [
		(html tag: 'caption')
			with: self description caption ]! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 3/9/2006 11:34'!
renderTableContentOn: html! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 3/9/2006 11:34'!
renderTableEmptyOn: html! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 3/10/2007 09:47'!
renderTableFootOn: html
	(html tag: 'tfoot') with: [
		self description showFooter
			ifTrue: [ self renderTableFooterOn: html ] ]! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 3/9/2006 11:34'!
renderTableFooterOn: html! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 3/10/2007 09:47'!
renderTableHeadOn: html
	(html tag: 'thead') with: [
		self description showHeader
			ifTrue: [ self renderTableHeaderOn: html ] ]! !

!MAReportComponent methodsFor: 'rendering-content' stamp: 'lr 3/9/2006 11:34'!
renderTableHeaderOn: html
	html tableRow: [
		self description do: [ :each |
			each isVisible ifTrue: [
				html tableData: each label ] ] ]! !

!MAReportComponent methodsFor: 'rendering-parts' stamp: 'lr 8/14/2008 00:22'!
renderTableSummaryOn: html
	self description summary isNil ifFalse: [
		(html tag: 'summary')
			with: self description summary ]! !

MAComponent subclass: #MAReport
	instanceVariableNames: 'rows cache columns properties backtracked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2000
	^ MABooleanDescription new
		accessor: #showHeader;
		label: 'Show Header';
		priority: 2000;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2100
	^ MABooleanDescription new
		accessor: #showBody;
		label: 'Show Body';
		priority: 2100;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2200
	^ MAStringDescription new
		accessor: #tableEmpty;
		label: 'Empty';
		priority: 2200;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2300
	^ MABooleanDescription new
		accessor: #showFooter;
		label: 'Show Footer';
		priority: 2300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2400
	^ MABooleanDescription new
		accessor: #showCaption;
		label: 'Show Caption';
		priority: 2300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2500
	^ MAStringDescription new
		accessor: #tableCaption;
		label: 'Caption';
		priority: 2500;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2600
	^ MABooleanDescription new
		accessor: #showSummary;
		label: 'Show Summary';
		priority: 2600;
		yourself! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 4/10/2008 14:17'!
description2700
	^ MAStringDescription new
		accessor: #tableSummary;
		label: 'Summary';
		priority: 2700;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4000
	^ MABooleanDescription new
		accessor: #showBatch;
		label: 'Show Batch';
		priority: 4000;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4100
	^ MANumberDescription new
		accessor: #batchSize;
		label: 'Size';
		priority: 4100;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4200
	^ MABooleanDescription new
		accessor: #showBatchFirstLast;
		label: 'Show First/Last';
		priority: 4200;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4300
	^ MABooleanDescription new
		accessor: #showBatchPreviousNext;
		label: 'Show Previous/Next';
		priority: 4300;
		yourself! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 4/10/2008 14:17'!
description4400
	^ MABooleanDescription new
		accessor: #showBatchPages;
		label: 'Show Pages';
		priority: 4400;
		yourself! !

!MAReport class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
rows: aCollection
	^ self new
		rows: aCollection;
		yourself! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 12/3/2006 22:06'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asContainer do: [ :each |
		report addColumnDescription: each ].
	^ report! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:34'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^ aColumn setReport: self; yourself! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:33'!
addColumnCascade: anArray
	^ (self addColumn: MAColumn new)
		cascade: anArray;
		yourself! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:34'!
addColumnDescription: aDescription
	^ self addColumn: (aDescription reportColumnClass new
		setDescription: aDescription;
		yourself)! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:34'!
addColumnSelector: aSelector
	^ (self addColumn: MAColumn new)
		selector: aSelector;
		yourself! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
batchEndIndex
	^ self batchPage * self batchSize min: self cache size! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
batchMaxPages
	^ (self cache size / self batchSize)
		ceiling! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:19'!
batchPage
	^ backtracked at: #batchPage ifAbsentPut: [ self defaultBatchPage ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:19'!
batchPage: anInteger
	backtracked at: #batchPage put: anInteger! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
batchPageRange
	^ self batchPageRangeStart to: self batchPageRangeEnd! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 9! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 9! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:24'!
batchSize
	^ properties at: #batchSize ifAbsent: [ self defaultBatchSize ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:19'!
batchSize: anInteger
	properties at: #batchSize put: anInteger! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:33'!
batchStartIndex
	^ (self batchPage - 1) * self batchSize + 1! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 6/5/2008 13:40'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [
		self cache: (self
			sortRows: (self
				filterRows: self
					rows asArray)) ].
	^ cache! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:33'!
cache: aCollection
	cache := aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:34'!
columns
	^ columns! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:34'!
columns: aCollection
	columns := aCollection! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultBatchPage
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultBatchSize
	^ 10! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultRowFilter
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultRowPeriod
	^ 1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultRowStyles
	^ Array with: 'odd' with: 'even'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowBatch
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowBatchFirstLast
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowBatchPages
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowBatchPreviousNext
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowBody
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowCaption
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultShowFooter
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowHeader
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultShowSummary
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultSortColumn
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultSortEnabled
	^ true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultSortReversed
	^ false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 11/7/2008 16:05'!
defaultSorterStyles
	^ Array with: 'ascending' with: 'descending'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTableCaption
	^ nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultTableEmpty
	^ 'The report is empty.'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:34'!
defaultTableSummary
	^ nil! !

!MAReport methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:34'!
export
	^ String streamContents: [ :stream |
		self exportOn: stream ]! !

!MAReport methodsFor: 'exporting' stamp: 'lr 9/26/2007 18:47'!
exportBodyOn: aStream
	self cache withIndexDo: [ :row :index |
		self visibleColumns
			do: [ :column |
				column
					exportContent: (column valueFor: row)
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream cr ]! !

!MAReport methodsFor: 'exporting' stamp: 'lr 9/26/2007 18:48'!
exportHeaderOn: aStream
	self visibleColumns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream cr! !

!MAReport methodsFor: 'exporting' stamp: 'lr 3/9/2006 11:33'!
exportOn: aStream
	self showHeader
		ifTrue: [ self exportHeaderOn: aStream ].
	self showBody
		ifTrue: [ self exportBodyOn: aStream ]! !

!MAReport methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
filterRows: aCollection
	^ self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ]! !

!MAReport methodsFor: 'testing' stamp: 'pmm 7/27/2006 19:41'!
hasMoreThanOnePage
	^self batchSize < self cache size! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
hasRowFilter
	^ self rowFilter notNil! !

!MAReport methodsFor: 'initialization' stamp: 'lr 11/28/2007 19:16'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.
	backtracked := Dictionary new! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:33'!
isOnFirstPage
	^ self batchPage = 1! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/9/2006 11:34'!
isOnLastPage
	^ self batchPage = self batchMaxPages! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/9/2006 11:33'!
isSorted
	^ self sortColumn notNil! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:33'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ])! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:34'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ])! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
nextPage
	self isOnLastPage
		ifFalse: [ self batchPage: self batchPage + 1 ]! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
previousPage
	self isOnFirstPage
		ifFalse: [ self batchPage: self batchPage - 1 ]! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [ :each | each refresh ]! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/9/2006 11:33'!
remove: aColumn
	columns := columns copyWithout: aColumn! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 11/16/2006 18:56'!
renderBatchFirstOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self batchPage: self defaultBatchPage ]; with: '|<' ]
		ifTrue: [ html text: '|<' ].
	html space! !

!MAReport methodsFor: 'rendering-batch' stamp: 'pmm 9/5/2007 07:24'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ html text: '...'; space ].
	self batchPageRange do: [ :index |
		self batchPage = index
			ifFalse: [ html anchor callback: [ self batchPage: index ]; with: index ]
			ifTrue: [ html span class: 'current'; with: index ].
		html space ].
	self batchPageRangeEnd < (self batchMaxPages - 1)
		ifTrue: [ html text: '...'; space ].
	self batchPageRangeEnd = self batchMaxPages
		ifFalse: [
			html anchor
				callback: [ self batchPage: self batchMaxPages ];
				with: self batchMaxPages ]! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 11/16/2006 18:56'!
renderBatchLastOn: html
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self batchPage: self batchMaxPages ]; with: '>|' ]
		ifTrue: [ html text: '>|' ]! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 11/16/2006 18:56'!
renderBatchNextOn: html
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ].
	html space! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 11/16/2006 18:56'!
renderBatchPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!MAReport methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:34'!
renderContentOn: html
	html table
		id: self ajaxId; class: 'report';
		with: [ self renderTableOn: html ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 9/26/2007 18:49'!
renderTableBatchOn: html
	self hasMoreThanOnePage ifTrue: [
		html tableRow: [
			html tableData
				class: 'batch';
				colSpan: self visibleColumns size;
				with: [
					self showBatchFirstLast
						ifTrue: [ self renderBatchFirstOn: html ].
					self showBatchPreviousNext
						ifTrue: [ self renderBatchPreviousOn: html ].
					self showBatchPages
						ifTrue: [ self renderBatchItemsOn: html ].
					self showBatchPreviousNext
						ifTrue: [ self renderBatchNextOn: html ].
					self showBatchFirstLast
						ifTrue: [ self renderBatchLastOn: html ] ] ] ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 4/10/2008 14:06'!
renderTableBodyOn: html 
	self visible isEmpty 
		ifTrue: [ 
			html tableRow
				class: 'empty';
				with: [ 
					html tableData
						colSpan: self visibleColumns size;
						with: self tableEmpty ] ]
		ifFalse: [
			self visible keysAndValuesDo: [ :index :row | 
				html tableRow
					class: (self rowStyleForNumber: index);
					with: [ 
						self visibleColumns do: [ :col | 
							col 
								renderCell: row
								index: index
								on: html ] ] ] ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/9/2006 11:34'!
renderTableCaptionOn: html
	(html tag: 'caption') with: self tableCaption! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 9/26/2007 18:48'!
renderTableFootOn: html
	html tableRow: [
		self visibleColumns do: [ :each |
			each renderFootCellOn: html ] ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 9/26/2007 18:48'!
renderTableHeadOn: html
	html tableRow: [
		self visibleColumns do: [ :each |
			each renderHeadCellOn: html ] ]! !

!MAReport methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:06'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tableHead: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].

	((self showBatch
		and: [ self hasMoreThanOnePage ])
		or: [ self showFooter ]) ifTrue: [
			"we must not produce an empty tfoot element, this is not valid xhtml"
			html tableFoot: [
				self showFooter
					ifTrue: [ self renderTableFootOn: html ].
				self showBatch
					ifTrue: [ self renderTableBatchOn: html ] ] ].

	html tableBody: [
		self showBody
			ifTrue: [ self renderTableBodyOn: html ] ]! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/9/2006 11:34'!
renderTableSummaryOn: html
	(html tag: 'summary') with: self tableSummary! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
rowFilter
	^ backtracked at: #rowFilter ifAbsent: [ self defaultRowFilter ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:19'!
rowFilter: aBlock
	backtracked at: #rowFilter put: aBlock.
	self refresh! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
rowPeriod
	^ properties at: #rowPeriod ifAbsent: [ self defaultRowPeriod ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:24'!
rowPeriod: aNumber
	properties at: #rowPeriod put: aNumber! !

!MAReport methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
rowStyleForNumber: aNumber
	^ self rowStyles
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
rowStyles
	^ properties at: #rowStyles ifAbsent: [ self defaultRowStyles ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
rowStyles: aCollection
	properties at: #rowStyles put: aCollection! !

!MAReport methodsFor: 'accessing' stamp: 'lr 11/28/2007 19:16'!
rows
	"Return the rows of the receiver."

	^ rows! !

!MAReport methodsFor: 'accessing' stamp: 'lr 8/14/2008 11:55'!
rows: aCollection
	"Set the rows of the receiver."
	
	rows := aCollection.
	self refresh! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
showBatch
	^ properties at: #showBatch ifAbsent: [ self defaultShowBatch ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showBatch: aBoolean
	properties at: #showBatch put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
showBatchFirstLast
	^ properties at: #showBatchFirstLast ifAbsent: [ self defaultShowBatchFirstLast ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showBatchFirstLast: aBoolean
	properties at: #showBatchFirstLast put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
showBatchPages
	^ properties at: #showBatchPages ifAbsent: [ self defaultShowBatchPages ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showBatchPages: aBoolean
	properties at: #showBatchPages put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
showBatchPreviousNext
	^ properties at: #showBatchPreviousNext ifAbsent: [ self defaultShowBatchPreviousNext ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showBatchPreviousNext: aBoolean
	properties at: #showBatchPreviousNext put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:25'!
showBody
	^ properties at: #showBody ifAbsent: [ self defaultShowBody ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showBody: aBoolean
	properties at: #showBody put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
showCaption
	^ properties at: #showCaption ifAbsent: [ self defaultShowCaption ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showCaption: aBoolean
	properties at: #showCaption put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
showFooter
	^ properties at: #showFooter ifAbsent: [ self defaultShowFooter ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showFooter: aBoolean
	properties at: #showFooter put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
showHeader
	^ properties at: #showHeader ifAbsent: [ self defaultShowHeader ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showHeader: aBoolean
	properties at: #showHeader put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
showSummary
	^ properties at: #showSummary ifAbsent: [ self defaultShowSummary ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
showSummary: aBoolean
	properties at: #showSummary put: aBoolean! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/9/2006 11:34'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [ self sortReversed: true ]
				ifTrue: [ self sortColumn: nil; sortReversed: false ] ]
		ifFalse: [ self sortColumn: aColumn; sortReversed: false ].
	self refresh! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
sortColumn
	^ backtracked at: #sortColumn ifAbsent: [ self defaultSortColumn ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:23'!
sortColumn: aColumn
	backtracked at: #sortColumn put: aColumn! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
sortEnabled
	^ properties at: #sortEnabled ifAbsent: [ self defaultSortEnabled ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
sortEnabled: aBoolean
	properties at: #sortEnabled put: aBoolean! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
sortReversed
	^ backtracked at: #sortReversed ifAbsent: [ self defaultSortReversed ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
sortReversed: aBoolean
	backtracked at: #sortReversed put: aBoolean! !

!MAReport methodsFor: 'private' stamp: 'lr 3/9/2006 11:34'!
sortRows: aCollection
	^ self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
sorterStyles
	^ properties at: #sorterStyles ifAbsent: [ self defaultSorterStyles ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
sorterStyles: aCollection
	properties at: #sorterStyles put: aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 11/28/2007 20:42'!
states
	^ Array with: backtracked! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
tableCaption
	^ properties at: #tableCaption ifAbsent: [ self defaultTableCaption ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
tableCaption: aString
	properties at: #tableCaption put: aString! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
tableEmpty
	^ properties at: #tableEmpty ifAbsent: [ self defaultTableEmpty ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
tableEmpty: aString
	properties at: #tableEmpty put: aString! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:26'!
tableSummary
	^ properties at: #tableSummary ifAbsent: [ self defaultTableSummary ]! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 11/28/2007 19:22'!
tableSummary: aString
	properties at: #tableSummary put: aString! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:34'!
visible
	^ self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ]! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 9/26/2007 18:47'!
visibleColumns
	^ self columns select: [ :each | each isVisible ]! !

WAComponent subclass: #MAExampleEditor
	instanceVariableNames: 'description report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

MAExampleEditor subclass: #MADescriptionEditor
	instanceVariableNames: 'example selected selectedComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MADescriptionEditor class methodsFor: 'initialization' stamp: 'lr 8/14/2008 11:48'!
initialize
	self registerAsApplication: 'magritte/editor'! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 11/20/2007 08:53'!
addDescription: aDescription
	| element |
	element := self call: (self
		buildEditorFor: aDescription
		titled: 'Add ' , aDescription class label).
	element isNil ifTrue: [ ^ self ].
	self description add: element.
	self refresh! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 8/14/2008 12:22'!
buildReport
	^ (MAReport rows: self description children description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'mb 4/10/2008 01:52'!
children
	^super children copyWith: selectedComponent! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:33'!
defaultDescription
	^ MAContainer new! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:33'!
defaultDescriptionClasses
	^ OrderedCollection new
		add: MAStringDescription;
		add: MAMemoDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: nil;
		add: MABooleanDescription;
		add: MASingleOptionDescription;
		add: MAMultipleOptionDescription;
		add: MAToOneRelationDescription;
		add: MAToManyRelationDescription;
		add: nil;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: nil;
		add: MAColorDescription;
		add: MATokenDescription;
		add: nil;
		add: MAFileDescription;
		add: MAClassDescription;
		add: MATableDescription;
		yourself! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 11/20/2007 08:51'!
defaultExampleInstance
	^ MAAdaptiveModel description: self description! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 11/20/2007 08:53'!
editDescription: aDescription
	self call: (self
		buildEditorFor: aDescription
		titled: 'Edit ' , aDescription class label).
	self refresh! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 11/20/2007 08:49'!
example
	^ example ifNil: [ example := self defaultExampleInstance ]! !

!MADescriptionEditor methodsFor: 'initialize-release' stamp: 'mb 4/10/2008 01:50'!
initialize
	super initialize.
	selected :=  MADescriptionHolder new.
	selectedComponent := selected asComponent
! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
preview
	self call: (self example asComponent
		addMessage: self description label;
		addValidatedForm;
		yourself)! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 11/20/2007 08:53'!
removeDescription: aDescription
	self description remove: aDescription.
	self refresh! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'sebh 6/14/2009 17:45'!
renderButtonsOn: html
	html submitButton
		callback: [
			selectedComponent save.
			selected contents isNil
				ifFalse: [ self addDescription: selected contents new ] ];
		id: 'button', self description label, 'Add';
		text: 'Add'.
	super renderButtonsOn: html! !

!MAExampleEditor class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:34'!
description: aDescription
	^ self new
		description: aDescription;
		yourself! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildEditorFor: anObject titled: aString
	^ anObject asComponent
		addValidatedForm;
		addMessage: aString;
		yourself! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildReport
	self subclassResponsibility! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
cancel
	self answer: nil! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
children
	^ Array with: self report! !

!MAExampleEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:33'!
defaultDescription
	self subclassResponsibility! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
description
	^ description ifNil: [ description := self defaultDescription ]! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
description: aDescription
	description := aDescription! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
edit
	self call: (self
		buildEditorFor: description
		titled: 'Edit Container')! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 11/20/2007 08:53'!
moveDown: aDescription
	self description moveDown: aDescription.
	self refresh! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 11/20/2007 08:53'!
moveUp: aDescription
	self description moveUp: aDescription.
	self refresh! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
preview
	self subclassResponsibility! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 11/20/2007 08:54'!
refresh
	self report rows: self description children! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:16'!
renderButtonsOn: html
	html submitButton on: #edit of: self.
	html submitButton on: #preview of: self! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/9/2006 11:33'!
renderChildrenOn: html
	html render: self children! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'mb 4/10/2008 07:14'!
renderContentOn: html
	html form: [
		self renderChildrenOn: html. "One of the children supplies input for the form"
		self renderButtonsOn: html ]! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
report
	^ report ifNil: [ report := self buildReport ]! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
save
	self answer: self description! !

!MATimeDescription class methodsFor: '*magritte-seaside' stamp: 'pmm 10/22/2006 13:06'!
defaultComponentClasses
	^ Array with: MATimeInputComponent with: MATimeSelectorComponent! !

!MATimeStampDescription class methodsFor: '*magritte-seaside' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATimeStampInputComponent! !

!MABooleanDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MACheckboxComponent with: MASelectListComponent with: MARadioGroupComponent! !

!MAToManyRelationDescription class methodsFor: '*magritte-seaside-accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAOneToManyComponent! !

!MAMultipleErrors methodsFor: '*magritte-seaside-rendering' stamp: 'lr 1/30/2008 09:45'!
renderOn: html
	html unorderedList: [
		self collection
			do: [ :each | html listItem: each ] ]! !

!MATableDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATableComponent! !

!MANumberDescription class methodsFor: '*magritte-seaside' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATextInputComponent with: MARangeComponent! !

!MAMultipleOptionDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAMultiselectListComponent with: MACheckboxGroupComponent with: MAListCompositonComponent! !

!MAMemoDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATextAreaComponent! !

!MAContainer class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAContainerComponent! !

!MAContainer class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentRenderer
	^ MATableRenderer! !

!MAContainer methodsFor: '*magritte-seaside-converting' stamp: 'lr 3/9/2006 11:33'!
asComponentOn: anObject
	^ self componentClass
		memento: (anObject mementoClass
			model: anObject
			description: self)! !

!MAContainer methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
componentRenderer
	^ self propertyAt: #componentRenderer ifAbsent: [ self class defaultComponentRenderer ]! !

!MAContainer methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
componentRenderer: aClass
	self propertyAt: #componentRenderer put: aClass! !

!MAToManyScalarRelationDescription class methodsFor: '*magritte-seaside-accessing-defaults' stamp: 'pmm 11/3/2006 17:49'!
defaultComponentClasses
	^ Array with: MAOneToManyScalarComponent! !

!MAToManyScalarRelationDescription class methodsFor: '*magritte-seaside-accessing-defaults' stamp: 'pmm 11/3/2006 18:03'!
defaultReportColumnClasses
	^ Array with: MADescribedScalarColumn! !

!MADescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClass
	^ self defaultComponentClasses isEmpty
		ifTrue: [ MAUndefinedComponent ]
		ifFalse: [ self defaultComponentClasses first ]! !

!MADescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAUndefinedComponent! !

!MADescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 1/10/2008 16:12'!
defaultCssClasses
	^ OrderedCollection new! !

!MADescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultReportColumnClass
	^ self defaultReportColumnClasses notEmpty
		ifTrue: [ self defaultReportColumnClasses first ]! !

!MADescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultReportColumnClasses
	^ Array with: MADescribedColumn! !

!MADescription class methodsFor: '*magritte-seaside-description' stamp: 'lr 4/10/2008 14:17'!
descriptionComponentClass
	^ MASingleOptionDescription new
		accessor: #componentClass;
		label: 'Component Class';
		reference: MAClassDescription new;
		options: self defaultComponentClasses;
		default: self defaultComponentClass;
		priority: 1000;
		yourself! !

!MADescription class methodsFor: '*magritte-seaside-description' stamp: 'lr 4/10/2008 14:17'!
descriptionReportColumnClass
	^ MASingleOptionDescription new
		accessor: #reportColumnClass;
		label: 'Report Column Class';
		priority: 1010;
		reference: MAClassDescription new;
		options: self defaultReportColumnClasses;
		default: self defaultReportColumnClass;
		yourself! !

!MADescription class methodsFor: '*magritte-seaside-examples' stamp: 'mb 4/10/2008 01:20'!
grouping
	^MADescriptionHolder groupOf: self! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
componentClass
	^ self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ]! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
componentClass: aClass
	^ self propertyAt: #componentClass put: aClass! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 1/10/2008 16:14'!
cssClass: aString
	(self propertyAt: #cssClasses ifAbsentPut: [ self class defaultCssClasses ])
		add: aString! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 1/10/2008 16:14'!
cssClasses
	^ self propertyAt: #cssClasses ifAbsent: [ self class defaultCssClasses ]! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 1/10/2008 15:57'!
cssClasses: aCollection
	^ self propertyAt: #cssClasses put: aCollection! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
reportColumnClass
	^ self propertyAt: #reportColumnClass ifAbsent: [ self class defaultReportColumnClass ]! !

!MADescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 3/9/2006 11:33'!
reportColumnClass: aClass
	^ self propertyAt: #reportColumnClass put: aClass! !

!MAElementDescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 5/22/2007 22:33'!
checkboxLabel
	^ self propertyAt: #checkboxLabel ifAbsent: [ self label ]! !

!MAElementDescription methodsFor: '*magritte-seaside-accessing' stamp: 'lr 5/22/2007 22:33'!
checkboxLabel: aString
	self propertyAt: #checkboxLabel put: aString! !

!MATokenDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2007 15:27'!
defaultComponentClasses
	^ Array with: MATextInputComponent! !

!MAToOneRelationDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAExternalEditorComponent with: MAInternalEditorComponent! !

!MAStringDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATextInputComponent! !

!MAClassDescription class methodsFor: '*magritte-seaside-accessing-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MATextInputComponent! !

!MAColorDescription class methodsFor: '*magritte-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAColorComponent! !

!MAPasswordDescription class methodsFor: '*magritte-seaside-default' stamp: 'lr 9/21/2008 10:28'!
defaultComponentClasses
	^ Array with: MATextPasswordComponent with: MAVerifiedPasswordComponent with: MATextInputComponent! !
MADescriptionEditor initialize!
